<template></template>

<script>
    import { DatabaseFieldchangerEventBus } from '../DatabaseFieldchangerEventBus.js';

    export default {

        props: {
            classname: {
                type: String,
                required: true,
            },

            entity_id: {
                type: Number,
                required: true,
            },

            fieldname: {
                type: String,
                required: true,
            },

            current_value: {
                default: null,
            },

            label: {
                type: String,
            },

            disabled: {
                type: Boolean,
                default: false,
            },

            hint: {
                type: String,
            }
        },

        data: function () {
            return {
                isLoading: false,
                error: null,

                old_value: this.current_value,
                new_value: this.current_value,
            }
        },

        methods: {
            change() {
                this.isLoading = true;
                this.error = false;

                axios.post('/component/v1/pbro/databasefieldchanger/change', {
                    classname: this.classname,
                    entity_id: this.entity_id,
                    fieldname: this.fieldname,
                    new_value: this.new_value,
                    old_value: this.old_value,
                }).then(({data}) => {
                    this.old_value = data[this.fieldname];

                    DatabaseFieldchangerEventBus.$emit(this.classname + '::' + this.entity_id + '::' + this.fieldname + '::changed', data[this.fieldname]);

                    this.isLoading = false;
                }).catch(error => {
                    if (error.response.data.message) {
                        this.error = error.response.data.message;
                    }

                    this.isLoading = false;
                })
            }
        },

        computed: {
            identifier() {
                return (this.classname.substring(this.classname.lastIndexOf("\\") + 1, this.classname.length)).toLowerCase() + '-' + this.entity_id + '-' + this.fieldname;
            },
        }

    }
</script>